class PuzzlesController < ApplicationController
  before_action :set_contest
  before_action :set_puzzle, only: %i[ destroy edit update]

  def edit
    @title = "Edit contest puzzle"
  end

  def new
    @puzzle = Puzzle.new
    @title = "New contest puzzle"
  end

  def create
    @puzzle = Puzzle.new(puzzle_params)
    @puzzle.contest_id = @contest.id
    if @puzzle.save
      redirect_to contest_path(@contest)
    else
      @title = "New contest puzzle"
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @puzzle.update(puzzle_params)
      redirect_to @contest
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @puzzle.destroy
    redirect_to contest_path(@contest)
  end

  private

  def set_contest
    @contest = Contest.find(params[:contest_id])
  end

  def set_puzzle
    @puzzle = Puzzle.find(params[:id])
  end

  def puzzle_params
    params.expect(puzzle: [ :brand, :name, :image ])
  end
end
