class User < ApplicationRecord
  has_many :contests, dependent: :destroy
  has_many :sessions, dependent: :destroy
  has_secure_password

  normalizes :email_address, with: ->(e) { e.strip.downcase }

  validates :username, presence: true, uniqueness: true
end
